package uoc.tfc.clientbs;

import java.util.Iterator;

import uoc.tfc.database.Database;
import uoc.tfc.entities.HoraryEntry;
import uoc.tfc.ui.UIUtils;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;

/**
 * Activity for horary list configuration.
 * 
 * @author omnizeus
 *
 */
public class ConfigActivity extends ActionBarActivity {

	private UIUtils uiutils;
	
	// Edit fields
	private Spinner spinnerBlock1Hour;
	private Spinner spinnerBlock2Hour;
	private Spinner spinnerBlock3Hour;
	private Spinner spinnerBlock4Hour;

	private Spinner spinnerBlock1Minute;
	private Spinner spinnerBlock2Minute;
	private Spinner spinnerBlock3Minute;
	private Spinner spinnerBlock4Minute;
	
	private EditText editBlock1Label;
	private EditText editBlock2Label;
	private EditText editBlock3Label;
	private EditText editBlock4Label;
	
	ArrayAdapter<CharSequence> adapter1;
	ArrayAdapter<CharSequence> adapter2;
	ArrayAdapter<CharSequence> adapter3;
	ArrayAdapter<CharSequence> adapter4;
	ArrayAdapter<CharSequence> adaptermin;
	
	// Database
	private Database db;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_config);
		
		Log.d(this.getClass().getName(), "onCreate");

		this.spinnerBlock1Hour = (Spinner) findViewById(R.id.spinner_block1_hour);
		this.spinnerBlock2Hour = (Spinner) findViewById(R.id.spinner_block2_hour);
		this.spinnerBlock3Hour = (Spinner) findViewById(R.id.spinner_block3_hour);
		this.spinnerBlock4Hour = (Spinner) findViewById(R.id.spinner_block4_hour);

		this.spinnerBlock1Minute = (Spinner) findViewById(R.id.spinner_block1_minute);
		this.spinnerBlock2Minute = (Spinner) findViewById(R.id.spinner_block2_minute);
		this.spinnerBlock3Minute = (Spinner) findViewById(R.id.spinner_block3_minute);
		this.spinnerBlock4Minute = (Spinner) findViewById(R.id.spinner_block4_minute);
		
		this.adapter1 = ArrayAdapter.createFromResource(this, R.array.spinner_block1_hour, R.layout.myspinneritem);
		this.adapter2 = ArrayAdapter.createFromResource(this, R.array.spinner_block2_hour, R.layout.myspinneritem);
		this.adapter3 = ArrayAdapter.createFromResource(this, R.array.spinner_block3_hour, R.layout.myspinneritem);
		this.adapter4 = ArrayAdapter.createFromResource(this, R.array.spinner_block4_hour, R.layout.myspinneritem);
		this.adaptermin = ArrayAdapter.createFromResource(this, R.array.spinner_minute, R.layout.myspinneritem);
		
		adapter1.setDropDownViewResource(R.layout.myspinnerdropdown);
		adapter2.setDropDownViewResource(R.layout.myspinnerdropdown);
		adapter3.setDropDownViewResource(R.layout.myspinnerdropdown);
		adapter4.setDropDownViewResource(R.layout.myspinnerdropdown);
		adaptermin.setDropDownViewResource(R.layout.myspinnerdropdown);
		
		this.spinnerBlock1Hour.setAdapter(adapter1);
		this.spinnerBlock2Hour.setAdapter(adapter2);
		this.spinnerBlock3Hour.setAdapter(adapter3);
		this.spinnerBlock4Hour.setAdapter(adapter4);
		this.spinnerBlock1Minute.setAdapter(adaptermin);
		this.spinnerBlock2Minute.setAdapter(adaptermin);
		this.spinnerBlock3Minute.setAdapter(adaptermin);
		this.spinnerBlock4Minute.setAdapter(adaptermin);
		
		this.editBlock1Label = (EditText) findViewById(R.id.edit_block1_label);
		this.editBlock2Label = (EditText) findViewById(R.id.edit_block2_label);
		this.editBlock3Label = (EditText) findViewById(R.id.edit_block3_label);
		this.editBlock4Label = (EditText) findViewById(R.id.edit_block4_label);
		
		/**
		 * Prepare database
		 */
		db = new Database(getApplicationContext());
		
		this.LoadLocalHoraryData();
		
		this.uiutils = new UIUtils(this);
	}
	
	public void btnOK(View view) {
		String whereami = ":btnOK";
		try {
			String[] horarylist = new String[4];
			horarylist[0] = this.spinnerBlock1Hour.getSelectedItem().toString() + ":" + this.spinnerBlock1Minute.getSelectedItem().toString();
			horarylist[1] = this.spinnerBlock2Hour.getSelectedItem().toString() + ":" + this.spinnerBlock2Minute.getSelectedItem().toString();
			horarylist[2] = this.spinnerBlock3Hour.getSelectedItem().toString() + ":" + this.spinnerBlock3Minute.getSelectedItem().toString();
			horarylist[3] = this.spinnerBlock4Hour.getSelectedItem().toString() + ":" + this.spinnerBlock4Minute.getSelectedItem().toString();
			db.SaveLocalHoraryData(horarylist);
			super.finish();
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);			
		}
	}
	
	public void btnClose(View view) {
		super.finish();
	}
	
	private void LoadLocalHoraryData() {
		String whereami = ":LoadLocalHoraryData";
		Iterator<HoraryEntry> horarylist;
		try {
			horarylist = db.GetHoraryList().iterator();
			while(horarylist.hasNext()) {
				HoraryEntry horaryentry = horarylist.next();
				Log.d(this.getClass().getName() + whereami, horaryentry.getToma() + ", " + horaryentry.getHour() + ", " + horaryentry.getMinute() + ", " + horaryentry.getLabel());
				if (horaryentry.getToma()==1) {
					this.editBlock1Label.setText(horaryentry.getLabel());
					this.spinnerBlock1Hour.setSelection(this.adapter1.getPosition(uiutils.formatHValue(horaryentry.getHour())));
					this.spinnerBlock1Minute.setSelection(this.adaptermin.getPosition(uiutils.formatHValue(horaryentry.getMinute())));
				} else if (horaryentry.getToma()==2) {
					this.editBlock2Label.setText(horaryentry.getLabel());
					this.spinnerBlock2Hour.setSelection(this.adapter2.getPosition(uiutils.formatHValue(horaryentry.getHour())));
					this.spinnerBlock2Minute.setSelection(this.adaptermin.getPosition(uiutils.formatHValue(horaryentry.getMinute())));
				} else if (horaryentry.getToma()==3) {
					this.editBlock3Label.setText(horaryentry.getLabel());
					this.spinnerBlock3Hour.setSelection(this.adapter3.getPosition(uiutils.formatHValue(horaryentry.getHour())));
					this.spinnerBlock3Minute.setSelection(this.adaptermin.getPosition(uiutils.formatHValue(horaryentry.getMinute())));
				} else if (horaryentry.getToma()==4) {
					this.editBlock4Label.setText(horaryentry.getLabel());
					this.spinnerBlock4Hour.setSelection(this.adapter4.getPosition(uiutils.formatHValue(horaryentry.getHour())));
					this.spinnerBlock4Minute.setSelection(this.adaptermin.getPosition(uiutils.formatHValue(horaryentry.getMinute())));
				}
			}
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
		}
		
	}

	
}
