package uoc.tfc.clientbs;

import java.util.Timer;
import java.util.TimerTask;

import uoc.tfc.database.Database;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;

/**
 * Activity that is shown during startup App.
 * 
 * @author omnizeus
 *
 */
public class StartupActivity extends Activity {

	private int SPLASH_DELAY_MS = 500;
	
	// Database
	private Database db;
	
	/**
	 * On create event.
	 */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_startup);
		String whereami = ":onCreate";
		
		try {
			/**
			 * Preparing intent (to Login activity).
			 */
		    TimerTask task = new TimerTask() {
			      @Override
			      public void run() {
			    	  Intent mainIntent = new Intent().setClass(StartupActivity.this, LoginActivity.class);
			    	  startActivity(mainIntent);
			    	  finish(); //Destroy current activity in order to avoid user return here with Back button.
			      }
		    };
		    
			db = new Database(getApplicationContext());
		    
		    /**
		     * Delay the execution of this intent.
		     */
		    Timer timer = new Timer();
		    timer.schedule(task, this.SPLASH_DELAY_MS);
			
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
		}
	}

}
