package uoc.tfc.clientbs;

import uoc.tfc.database.Database;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;

/**
 * Activity for showing all user's take list.
 * 
 * @author omnizeus
 *
 */
public class ViewdataActivity extends ActionBarActivity {

	private ListView lvUserdata;
	
	// Database
	private Database db;
	
	/**
	 * On create event.
	 */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_viewdata);
		String whereami = ":onCreate";
		try {
			/**
			 * Prepare database
			 */
			db = new Database(getApplicationContext());
			
			/**
			 * Get view controls.
			 */
			lvUserdata = (ListView) findViewById(R.id.lv_userdata);

			/**
			 * Set array adapter for listview.
			 */
			ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, R.layout.mylistviewitem, db.GetStoredTakeList());
			lvUserdata.setAdapter(adapter);
			
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
		}
		
	}
	
	/**
	 * OK button (exit view).
	 * 
	 * @param view
	 */
	public void btnOK(View view) {
		super.finish();
	}
	
}
