package uoc.tfc.entities;

/**
 * Entity for storing a user (service access data and user/password).
 * 
 * @author omnizeus
 *
 */
public class User {

	private String nickname;
	private String password;
	private String idpatientph;
	private String clientbspassword;

	public String getNickname() {
		return nickname;
	}

	public void setNickname(String nickname) {
		this.nickname = nickname;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getIdpatientph() {
		return idpatientph;
	}

	public void setIdpatientph(String idpatientph) {
		this.idpatientph = idpatientph;
	}

	public String getClientbspassword() {
		return clientbspassword;
	}

	public void setClientbspassword(String clientbspassword) {
		this.clientbspassword = clientbspassword;
	}

	/**
	 * Constructor.
	 */
	public User() {
		super();
	}

	/**
	 * Constructor with field names.
	 * 
	 * @param nickname
	 * @param password
	 * @param idpatientph
	 * @param clientbspassword
	 */
	public User(String nickname, String password, String idpatientph,
			String clientbspassword) {
		super();
		this.nickname = nickname;
		this.password = password;
		this.idpatientph = idpatientph;
		this.clientbspassword = clientbspassword;
	}

	/**
	 * Comparator. For testing purposes only.
	 * 
	 */
	@Override
	public boolean equals(Object o) {
		try {
			User ouser = (User) o;
			return (this.nickname.equals(ouser.getNickname())
					&& this.password.equals(ouser.getPassword())
					&& this.idpatientph.equals(ouser.getIdpatientph()) && this.clientbspassword
						.equals(ouser.getClientbspassword()));
		} catch (Exception e) {
			return false;
		}
	}

}
