package uoc.tfc.httpman;

import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.CookieStore;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.protocol.ClientContext;
import org.apache.http.conn.HttpHostConnectException;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.EntityUtils;

import uoc.tfc.ui.UIUtils;
import android.util.Log;

/**
 * Class containing http operations with BS Servlet.
 * 
 * @author omnizeus
 */
public class HttpHelper {

	//LOCAL MODE:
	/*
	public static String CONN_PROTOCOL = "http://";
	public static String CONN_HOST = "192.168.1.11";
	public static String CONN_PORT = ":8080";
	public static int CONN_PORT_I = 8080;
	public static String CONN_SERVICE = "Awebpfcw2";
	*/
	
	//INTERNET MODE: (NOTE THAT SENSITIVE DATA WAS REMOVED)
	public static String CONN_PROTOCOL = "http://";
	public static String CONN_HOST = "clientbsserver.url.com";
	public static String CONN_PORT = "";
	public static int CONN_PORT_I = 80;
	public static String CONN_SERVICE = "WebApplicationName";
	
	public static String BSSERVICE_NICKNAME = "clientbs@dev00010";
	public static String BSSERVICE_PASSWORD = "Tfc2014#$";
	
	public static String RESP_NOINIT = "-1#Sin inicializar";
	
	public static String RESP_SUCCESS_LOGIN_CONNECTING = "0#Connectant...";
	public static String RESP_SUCCESS_LOGIN_CORRECT = "1#Connectat";
	public static String RESP_SUCCESS_SERVICE_AVAILABLE = "2#Servei disponible";
	public static String RESP_SUCCESS_LOGIN_BYPASS = "10#ByPass...";
	
	public static String RESP_SUCCESS_PATIENT_DATA_OK = "20#Obtingudes de les dades de l'usuari";
	public static String RESP_SUCCESS_PATIENT_NO_DATA = "21#L'usuari no té dosificació planificada";
	public static String RESP_SUCCESS_LOGOUT = "30#Desconexió";

	public static String RESP_ERROR_LOGIN_SERVICE_UNAVAILABLE = "-1#Servicio no disponible";
	public static String RESP_ERROR_LOGIN_INCORRECT = "-2#Dades d'inici incorrectes";
	public static String RESP_ERROR_PATIENT_DATA_ERR = "-3#Usuari no existent";
	public static String RESP_ERROR_LOGOUT = "-30#Desconexió incorrecta";
	
	public static String RESP_EXCEPTION_UNHANDLED = "-100#Excepció no control·lada";
	
	//Delay for testing purposes.
	//public static int CONN_DELAY = 50;
	public static int CONN_DELAY = 0;
	
	//Apache CookieStore
	private CookieStore cookieStore = null;
	private HttpContext httpContext = null;
	
	/**
	 * Constructor.
	 * @param cookiestore
	 * @param httpcontext
	 */
	public HttpHelper(CookieStore cookiestore, HttpContext httpcontext) {
    	//Enable http cookies/session
    	cookieStore = cookiestore;
    	httpContext = httpcontext;
    	httpContext.setAttribute(ClientContext.COOKIE_STORE, this.cookieStore);
	}
	
	/**
	 * Check BS service. (PING style)
	 * @return
	 */
	public String check() {
		String whereami = ":check";
		Boolean res = false;
		String response = HttpHelper.RESP_NOINIT;
		try {
			res = reachable(CONN_HOST, CONN_PORT_I);
			if(res) {
				response = HttpHelper.RESP_SUCCESS_SERVICE_AVAILABLE;
			} else {
				response = HttpHelper.RESP_ERROR_LOGIN_SERVICE_UNAVAILABLE;
			}
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
			response = HttpHelper.RESP_EXCEPTION_UNHANDLED;
		}
		return response;
	}
	
	/**
	 * Login in BS Servlet (this is service user, not patient user).
	 * @param nickname
	 * @param password
	 * @return
	 */
	public String login(String nickname, String password) {
		String whereami = ":login";
		Boolean res = false;
		String response = "NONE";
		try {
			List<NameValuePair> params = new ArrayList<NameValuePair>(3);
			params.add(new BasicNameValuePair("nickname", nickname));
			params.add(new BasicNameValuePair("password", password));
			response = _httpReq(CONN_PROTOCOL + CONN_HOST + CONN_PORT + "/" + CONN_SERVICE + "/Sapp?/usuaris.validasession", params);
			//res = (response.contains("div#menu"));
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
			response = e.toString();
			res = false;
		}
		return response;
	}

	/**
	 * First servlet action for testing purposes.
	 * @return
	 */
	public String test() {
		String whereami = ":test";
		String response = "";
		try {
			response = _httpReq(CONN_PROTOCOL + CONN_HOST + CONN_PORT + "/" + CONN_SERVICE + "/Sapp?/usuaris.test");
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
			response = "";
		}
		return response;
	}
	
	/**
	 * Logout in BS Service (this is service logout, not patient logout).
	 * @return
	 */
	public Boolean logout() {
		String whereami = ":logout";
		Boolean res = false;
		try {
			res = (_httpReq(CONN_PROTOCOL + CONN_HOST + CONN_PORT + "/" + CONN_SERVICE + "/Sapp?/usuaris.logout").contains(""));
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
			res = false;
		}
		return res;
	}
	
	/**
	 * Get all the product take list for the patient/password selected.
	 * @param idpatientph
	 * @param clientbspassword
	 * @return
	 */
	public String clientbsGetpatientdata(String idpatientph, String clientbspassword) {
		String whereami = ":clientbsGetpatientdata";
		String response = "";
		try {
			List<NameValuePair> params = new ArrayList<NameValuePair>(3);
			params.add(new BasicNameValuePair("idpatientph", idpatientph));
			params.add(new BasicNameValuePair("clientbspassword", clientbspassword));
			params.add(new BasicNameValuePair("posologydate", UIUtils.getCurrentDate()));
			// Force date for testing purposes
			//params.add(new BasicNameValuePair("posologydate", "2014-12-07"));
			Log.d(this.getClass().getName() + whereami, idpatientph + "; " + UIUtils.getCurrentDate());
			response = _httpReq(CONN_PROTOCOL + CONN_HOST + CONN_PORT + "/" + CONN_SERVICE + "/Sapp?/app.clientbsGetpatientdata", params);
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
			response = "";
		}
		return response;
	}
	
	/**
	 * Quick access to _httpReq without params.
	 * @param url
	 * @return
	 * @throws Exception
	 */
	private String _httpReq(String url) throws Exception {
		return _httpReq(url, null);
	}
	
	/**
	 * Manages http request.
	 * @param url
	 * @param params
	 * @return
	 * @throws Exception
	 */
	private String _httpReq(String url, List<NameValuePair> params) throws Exception {
		String whereami = ":_httpReq";
		String response = "";
		DefaultHttpClient httpClient = null;
		//HttpParams httpParams = null;
		HttpPost httpPost = null;
		HttpResponse httpResponse = null;		
		try {
			if (CONN_DELAY>0) Thread.sleep(CONN_DELAY);
			Log.d("_httpReq", "Init: " + url);
			httpClient = new DefaultHttpClient();
			httpPost = new HttpPost(url);
			Log.d("_httpReq", "Before execute.")	;
			Log.d("_httpReq", "Params is null: " + (params==null));
			if (params!=null && params.size()>0) {
				Log.d("_httpReq", "Setting params.");
				httpPost.setEntity(new UrlEncodedFormEntity(params));
				Log.d("_httpReq", "params: " + params.toString());
			}
			if (CONN_DELAY>0) Thread.sleep(CONN_DELAY);
			//httpParams = httpClient.getParams();
			//HttpConnectionParams.setConnectionTimeout(httpParams, 2000);
			//HttpConnectionParams.setSoTimeout(httpParams, 2000);
			httpResponse = httpClient.execute(httpPost, httpContext);
			//Log.d("_httpReq", "httpResponse: " + httpResponse.getStatusLine());
			response = EntityUtils.toString(httpResponse.getEntity());
			//Log.d("_httpReq", "response: " + response);
		} catch (ClientProtocolException e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
			httpPost.abort();
			throw new Exception("[2] No se puede conectar con el host.");
		} catch (HttpHostConnectException e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
			httpPost.abort();
			throw new Exception("[3] No se puede conectar con el host.");
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
			httpPost.abort();
			throw new Exception("[4] Excepción no controlada: " + e.toString());
		}
		Log.d("_httpReq", "end");
		return response;
	}
	
	/**
	 * Check is hostname/port service is reachable.
	 * @param hostname
	 * @param port
	 * @return
	 */
	private Boolean reachable(String hostname, Integer port) {
		String whereami = ":reachable";
		Socket socket = null;
		boolean reachable = false;
		try {
			Thread.sleep(CONN_DELAY);
		    socket = new Socket(hostname, port);
		    Thread.sleep(CONN_DELAY);
		    reachable = true;
		} catch (Exception e) {
			Log.e(this.getClass().getName() + whereami, "Exception", e);
			reachable = false;
		} finally {            
		    if (socket != null) try { socket.close(); } catch(IOException e) {}
		}
		return reachable;
	}

}
