package uoc.tfc.ui;

import java.text.SimpleDateFormat;
import java.util.Date;

import uoc.tfc.clientbs.MainActivity;
import uoc.tfc.clientbs.R;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.media.MediaPlayer;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.Vibrator;
import android.support.v4.app.NotificationCompat;
import android.support.v4.app.NotificationCompat.Builder;
import android.widget.Toast;

/**
 * UI utilites.
 * 
 * @author omnizeus
 *
 */
public final class UIUtils {

	private static Context context;
	private static int notificationCounter;

	private static Toast mainToast; // Necessary?

	public UIUtils(Context context) {
		super();
		UIUtils.context = context;
		// UIUtils.mainToast = Toast.makeText(context, "", Toast.LENGTH_SHORT);

	}

	public UIUtils(Context context, Toast mainToast) {
		super();
		UIUtils.context = context;
		// UIUtils.mainToast = mainToast;
	}

	public UIUtils(Context context, Toast mainToast, MediaPlayer mediaPlayer,
			Builder notificationBuilder, NotificationManager notificationManager) {
		super();
		UIUtils.context = context;
	}

	// Not used.

	/*
	 * public void setToast(String msg) { this.setToast(msg, 0, false, false); }
	 * 
	 * public void setToast(String msg, boolean queue) { this.setToast(msg, 0,
	 * queue, false); }
	 * 
	 * public void setToast(String msg, boolean queue, boolean audio) {
	 * this.setToast(msg, 0, queue, audio); }
	 * 
	 * public void setToast(String msg, int duration, boolean queue, boolean
	 * audio) { int durationR = (duration != 0 ? duration : Toast.LENGTH_SHORT);
	 * if (queue) { Toast.makeText(context, "### " + msg + " ###",
	 * durationR).show(); } else { if (UIUtils.mainToast == null) {
	 * UIUtils.mainToast = Toast.makeText(context, "", 0); } else {
	 * UIUtils.mainToast.cancel(); } UIUtils.mainToast.setDuration(durationR);
	 * UIUtils.mainToast.setText("*** " + msg + " ***");
	 * UIUtils.mainToast.show(); } if (audio) { playSound(-1); this._vibrate();
	 * } }
	 */

	public void setNotification(String title, String msg) {

		setNotification(this.context, title, msg, -1);

	}

	public void setNotification(String title, String msg, int resource) {

		setNotification(this.context, title, msg, resource);

	}

	public void setNotification(Context mycontext, String title, String msg,
			int resource) {
		Uri alarmSound;
		if (resource < 0) {
			alarmSound = RingtoneManager
					.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
		} else {
			alarmSound = Uri.parse("android.resource://"
					+ mycontext.getPackageName() + "/" + resource);
		}
		UIUtils.notificationCounter++;

		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String currentDateandTime = sdf.format(new Date());

		// Notification configuration
		NotificationCompat.Builder builder = new NotificationCompat.Builder(
				context)
				.setSmallIcon(R.drawable.ic_launcher)
				.setContentTitle(title)
				.setVibrate(new long[] { 0, 1000, 1000, 1000, 1000 })
				.setLights(Color.RED, 3000, 3000)
				.setPriority(NotificationCompat.PRIORITY_HIGH)
				.setContentTitle(
						currentDateandTime + " [" + UIUtils.notificationCounter
								+ "] " + title).setContentText(msg)
				.setStyle(new NotificationCompat.BigTextStyle().bigText(msg))
				.setContentInfo("info").setSound(alarmSound);

		Intent notificationIntent = new Intent(mycontext, MainActivity.class);
		PendingIntent contentIntent = PendingIntent.getActivity(mycontext, 0,
				notificationIntent, PendingIntent.FLAG_UPDATE_CURRENT);
		builder.setContentIntent(contentIntent);

		// Add as notification
		NotificationManager manager = (NotificationManager) mycontext
				.getSystemService(Context.NOTIFICATION_SERVICE);
		manager.notify(UIUtils.notificationCounter, builder.build());
		if (UIUtils.notificationCounter > 4)
			UIUtils.notificationCounter = 0;

		// UIUtils.mainToast.makeText(mycontext, msg,
		// Toast.LENGTH_SHORT).show();
		Toast.makeText(mycontext, msg, Toast.LENGTH_SHORT).show();

	}

	public void playSound(int resource) {

		Uri alarmSound;
		if (resource < 0) {
			alarmSound = RingtoneManager
					.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
		} else {
			alarmSound = Uri.parse("android.resource://"
					+ context.getPackageName() + "/" + resource);
			UIUtils.notificationCounter++;
		}

		// Notification configuration
		NotificationCompat.Builder builder = new NotificationCompat.Builder(
				context).setPriority(NotificationCompat.PRIORITY_HIGH)
				.setContentInfo("info").setSound(alarmSound);

		Intent notificationIntent = new Intent(context, MainActivity.class);
		PendingIntent contentIntent = PendingIntent.getActivity(context, 0,
				notificationIntent, PendingIntent.FLAG_UPDATE_CURRENT);
		builder.setContentIntent(contentIntent);

		// Add as notification
		NotificationManager manager = (NotificationManager) context
				.getSystemService(Context.NOTIFICATION_SERVICE);
		manager.notify(UIUtils.notificationCounter, builder.build());
		if (UIUtils.notificationCounter > 4)
			UIUtils.notificationCounter = 0;

	}

	/**
	 * Vibrate the device.
	 */
	private void vibrate() {
		Vibrator v = (Vibrator) context
				.getSystemService(Context.VIBRATOR_SERVICE);
		v.vibrate(500);
	}

	/**
	 * Format a horaryvalue.
	 * 
	 * @param horaryvalue
	 * @return
	 */
	public static String formatHValue(int horaryvalue) {
		return (horaryvalue <= 9 ? "0" : "") + String.valueOf(horaryvalue);
	}

	/**
	 * Format a horaryvalue combo (hour+minute).
	 * 
	 * @param hourvalue
	 * @param minutevalue
	 * @return
	 */
	public static String formatHValue(int hourvalue, int minutevalue) {
		return (hourvalue <= 9 ? "0" : "") + String.valueOf(hourvalue) + ":"
				+ (minutevalue <= 9 ? "0" : "") + String.valueOf(minutevalue);
	}

	/**
	 * Get current date in String format.
	 * 
	 * @return
	 */
	public static String getCurrentDate() {
		Date cDate = new Date();
		return new SimpleDateFormat("yyyy-MM-dd").format(cDate);
	}

}
